unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, myzipper;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    procedure ZipDir(ZipName, Directory:String);
    procedure UnzipDir(Filename, OutputPath:String);
  end;

var
  Form1: TForm1; 

implementation

var F:TFileStream;
    FZipper:TZipper;


{ TForm1 }

//Zip complete dir with subdirs
procedure TForm1.ZipDir(ZipName, Directory:String);
var DirFiles:TStrings;

//internal procedure to fill Stringlist "Dirfiles" with filepaths and -names
procedure GetFiles(Src:string);
var
  search:TSearchRec;
  verz, such, mask:string;

begin
  if Src[length(Src)]<>'\' then Src:=Src+'\';
  such:='*.*';
  verz:=Src;
  mask:=verz+such;

  //all files
  if FindFirst(mask,$23+faSysFile,search)=0 then
  begin
    repeat
      DirFiles.Add(src+search.Name);
    until (FindNext(search)<>0);
  end;
  FindClose(search);

  //Subdirectories/ Unterverzeichnisse
  if (FindFirst(Src+'*.*',faDirectory+faHidden+faSysFile+faReadOnly,search)=0) then
  begin
    repeat
      if ((search.Attr and fadirectory)=fadirectory) and (search.name<>'.')  and (search.name<>'..')then
      begin
        GetFiles(Src+search.name);
      end;
    until FindNext(search) <>0;
  end;
  FindClose(search);
end;
//end of internal procedure

begin
  FZipper:=TZipper.Create;
  DirFiles:=TStringList.Create;
  GetFiles(Directory);
  FZipper.ZipFiles(ZipName, DirFiles);
  DirFiles.Free;
  FZipper.Free;
end;

//unzip archive to outputdir
procedure TForm1.UnzipDir(Filename, OutputPath:String);
var FUnZipper:TUnZipper;
begin
  FUnZipper:=TUnzipper.Create;
  ForceDirectories(OutputPath);
  FUnZipper.OutputPath:=OutputPath;
  FUnzipper.UnZipAllFiles(Filename);
  FUnzipper.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ZipDir('test.zip', 'backup');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  UnzipDir('Test.zip', 'backup\test');
end;

initialization
  {$I main.lrs}

end.

